package beagle.bgtheory.LIA.iQE

import beagle._
import fol._
import util._
import datastructures.Clause
import bgtheory._
import LIA._

object Solver extends LIASolver {
  val name = "iQE"
  def hasSolverLiterals(cl: Clause) = true
  def toSolverLiterals(cl: Clause) = cl
  def check(cls: Iterable[Clause]) = {
    // for (cl <- cls) {
    //   println("cl:            " + cl)
    //   println("cl.isEmpty     " + cl.isEmpty)
    //   println("cl.asQEClause: " + cl.asQEClause)
    //   println("cl.asQEClause: " + cl.asQEClause.get)
    // }
    // val cooperRes = toSolverResult(cooper.isConsistent(cls))
    val iQERes = iQE.isConsistent(cls map { _.asQEClause.get })
    // println("iQERes = " + iQERes)

    // if (iQERes != cooperRes) {
    //   println("Internal error: diverging results in BG solvers:")
    //   println("\nCooper says " + cooperRes)
    //   println("iQE says    " + iQERes)
    //   println("Clause set:")
    //   cls foreach {
    //     println(_)
    //   }
    //   sys.exit()
    // }

    // println()
    // cooperRes
    iQERes
  }
  val needsUnitClauses = false
}

